﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections.ObjectModel;
using System.ComponentModel;

namespace BasicData
{
    public class GetBasicData
    {

        private static ObservableCollection<BasicData> basicData;

        private static  ObservableCollection<BasicData> GetBasicDataCollection()
        {
            //string department = "IT";

            ObservableCollection<BasicData> dataList = new ObservableCollection<BasicData>();

            //for (int i = 0; i < 10; i++)
            //{                
            //    dataList.Add( new BasicData( i.ToString(), 
            //        "Random name " + i.ToString(),
            //        department,
            //        i * 43.73,
            //        System.DateTime.Today.AddHours(i) )
            //        );
            //};

            return dataList;
        }

         public static ObservableCollection<BasicData> BasicDataCollection
        {
            get
            {
                if (basicData == null)
                    basicData = GetBasicDataCollection();

                return basicData;
            }
        }
        
               
    }

    public class BasicData : INotifyPropertyChanged
    {
        string id;
        string name;
        string department;
        double salary;
        DateTime date;
        

        public BasicData()
        {
        }

        public BasicData(string id, string name, string department, double salary, DateTime date)
        {
            this.ID = id;
            this.Name = name;
            this.Department = department;
            this.Salary = salary;
            this.Date = date;
            
        }

        public string ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }
        
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string Department
        {
            get { return department; }
            set
            {
                if (department != value)
                {
                    department = value;
                    OnPropertyChanged("Department");
                }
            }
        }

        public double Salary
        {
            get { return salary; }
            set
            {
                if (salary != value)
                {
                    salary = value;
                    OnPropertyChanged("Salary");
                }
            }
        }

        public DateTime Date
        {
            get { return date; }
            set
            {
                if (date != value)
                {
                    date = value;
                    OnPropertyChanged("Date");
                }
            }
        }
       

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }
    
}
